package cs.fsu.iwander;

import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.Scanner;
import java.util.regex.Pattern;

import android.util.Log;


public class BNContainer {

	private final static String TAG = "cs.fsu.iwander.BNContainer";
	
	RangeClassifier classifier = null;
	private int[] prob;


	public BNContainer(RangeClassifier ranges){
		classifier = ranges;
		prob = new int[8];
	}

	public boolean readFile(String fileName){
		try {
			Scanner scanner = new Scanner(new FileInputStream(fileName));
			
			scanner = scanner.skip("(^[0-9]|^[\n\t ])*");
			
			Log.i(TAG, "Read First = " + scanner.next());
			
			classifier.setSunRise(scanner.nextInt());
			classifier.setSunSet(scanner.nextInt());
			
			Log.i(TAG, "sunRise " + classifier.getSunRise() + " sunSet " + classifier.getSunSet());
			
			for(int x = 0; x < prob.length; x++){
				scanner = scanner.skip(Pattern.compile("\\D"));
				prob[x] = scanner.nextInt();
				Log.i(TAG, "prob[" + x + "] " + prob[x]);
			}
			
		} catch (Exception e) {
			Log.i(TAG, "Unable to parse file <" + fileName + ">");
			e.printStackTrace();
			return false;
		}
		
		return true;
	}
	
	public boolean writeFile(String fileName){
		
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(fileName));
			
			out.write("SunRise SunSet (in Miltary Time)\n");
			out.write(classifier.getSunRise() + " ");
			out.write(classifier.getSunSet() + "\n");
			
			out.write("isRaining, isExtremeTemp, isNight : wanderProbability\n");
			
			for(int x = 0; x < prob.length; x++)
				out.write(Integer.toBinaryString(prob[x]) + " : " + prob[x] + "\n");
		
			
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
		
		return true;
	}
	
	
	public int getProbability(ConditionNode node){
		return prob[classifier.getIndex(node)];
	}
	
	public void setProbability(int val, int index){
		prob[index] = val;
	}


};
