package cs.fsu.iwander;


public class RangeClassifier {
	
	private int lowTemp, highTemp,
			sunRise, sunSet;

	public RangeClassifier(){	
	}
	
	public RangeClassifier(int sunRise, int sunSet, int lowTemp, 
			int highTemp, int minPrec){
		this.lowTemp = lowTemp;
		this.highTemp = highTemp;
		this.sunRise = sunRise;
		this.sunSet = sunSet;
	}
	
	public RangeClassifier(int[] vals){
		if(vals.length < 4 || vals.length > 4)
			return;
		
		
		this.sunRise = vals[0];
		this.sunSet = vals[1];
		this.lowTemp = vals[2];
		this.highTemp = vals[3];
	}
	
	public int getLowTemp() {
		return lowTemp;
	}



	public void setLowTemp(int lowTemp) {
		this.lowTemp = lowTemp;
	}



	public int getHighTemp() {
		return highTemp;
	}



	public void setHighTemp(int highTemp) {
		this.highTemp = highTemp;
	}

	public int getSunRise() {
		return sunRise;
	}



	public void setSunRise(int sunRise) {
		this.sunRise = sunRise;
	}



	public int getSunSet() {
		return sunSet;
	}



	public void setSunSet(int sunSet) {
		this.sunSet = sunSet;
	}
	
	public int getIndex(ConditionNode node){
		int index = 0;
		
		if(isNight(node.getTime()))
			index += 1;
		
		if(isTemp(node.getTemp()))
			index += 2;
		
		if(node.isRain())
			index += 4;
		
		return index;
	}
	
	
	public boolean isNight(int time){
		if(time < sunRise || time > sunSet)
			return true;
		else
			return false;
	}
	
	public boolean isTemp(int temp){
		if(temp < lowTemp || temp > highTemp)
			return true;
		else
			return false;
	}
}
